/**
 * OverlayControllerWindow.m
 * NicePlayer
 */

/* ***** BEGIN LICENSE BLOCK *****
* Version: MPL 1.1/GPL 2.0/LGPL 2.1
*
* The contents of this file are subject to the Mozilla Public License Version
* 1.1 (the "License"); you may not use this file except in compliance with
* the License. You may obtain a copy of the License at
* http://www.mozilla.org/MPL/
*
* Software distributed under the License is distributed on an "AS IS" basis,
* WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
* for the specific language governing rights and limitations under the
* License.
*
* The Original Code is NicePlayer.
*
* The Initial Developer of the Original Code is
* James Tuley & Robert Chin.
* Portions created by the Initial Developer are Copyright (C) 2004-2006
* the Initial Developer. All Rights Reserved.
*
* Contributor(s):
*           Robert Chin <robert@osiris.laya.com> (NicePlayer Author)
*           James Tuley <jay+nicesource@tuley.name> (NicePlayer Author)
*
* Alternatively, the contents of this file may be used under the terms of
* either the GNU General Public License Version 2 or later (the "GPL"), or
* the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
* in which case the provisions of the GPL or the LGPL are applicable instead
* of those above. If you wish to allow use of your version of this file only
* under the terms of either the GPL or the LGPL, and not to allow others to
* use your version of this file under the terms of the MPL, indicate your
* decision by deleting the provisions above and replace them with the notice
* and other provisions required by the GPL or the LGPL. If you do not delete
* the provisions above, a recipient may use your version of this file under
* the terms of any one of the MPL, the GPL or the LGPL.
*
* ***** END LICENSE BLOCK ***** */

#import "OverlayControllerWindow.h"

@implementation OverlayControllerWindow

-(void)awakeFromNib
{
    [super awakeFromNib];
    [ffButton setContinuous:YES];
    [rrButton setContinuous:YES];
    
    [ffButton setPeriodicDelay:.5 interval:.2];
    [rrButton setPeriodicDelay:.5 interval:.2];
}

-(void)close
{
	[self removeChildWindow:overlayResize];
	[super close];
}

-(void)createResizeTriangle
{
    [self addChildWindow:overlayResize ordered:NSWindowAbove];    
    [self setHasShadow:NO];
    [overlayResize setFrame:[[self parentWindow] frame] display:NO];
    [overlayResize orderFront:self];
}

-(void)setAlphaValue:(float)windowAlpha
{
    [overlayResize setAlphaValue:windowAlpha];
    [super setAlphaValue:windowAlpha];
}

-(void)setFrame:(NSRect)frameRect display:(BOOL)flag
{
    [super setFrame:frameRect display:flag];

    NSRect movieRect = [[[self parentWindow] contentView] frame];
    movieRect.origin = [[self parentWindow] convertBaseToScreen:movieRect.origin];
    [overlayResize setFrame:movieRect display:flag];
    
}

-(void)setLevel:(int)newLevel
{
    [overlayResize setLevel:newLevel];
    [super setLevel:newLevel];
}

@end
